"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.highlightPlugin = void 0;
var _react = _interopRequireDefault(require("react"));
var _platformFeatureFlags = require("@atlaskit/platform-feature-flags");
var _commands = require("./commands");
var _keymap = require("./pm-plugins/keymap");
var _main = require("./pm-plugins/main");
var _FloatingToolbarHighlightColor = require("./ui/FloatingToolbarHighlightColor");
var _PrimaryToolbarHighlightColor = require("./ui/PrimaryToolbarHighlightColor");
var _ToolbarHighlightColor = require("./ui/ToolbarHighlightColor");
var highlightPlugin = exports.highlightPlugin = function highlightPlugin(_ref) {
  var _api$analytics;
  var api = _ref.api,
    options = _ref.config;
  var editorAnalyticsAPI = api === null || api === void 0 || (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions;
  var primaryToolbarComponent = function primaryToolbarComponent(_ref2) {
    var popupsMountPoint = _ref2.popupsMountPoint,
      popupsBoundariesElement = _ref2.popupsBoundariesElement,
      popupsScrollableElement = _ref2.popupsScrollableElement,
      disabled = _ref2.disabled,
      isToolbarReducedSpacing = _ref2.isToolbarReducedSpacing,
      editorView = _ref2.editorView;
    return (0, _platformFeatureFlags.getBooleanFF)('platform.editor.refactor-highlight-toolbar_mo0pj') ? /*#__PURE__*/_react.default.createElement(_PrimaryToolbarHighlightColor.PrimaryToolbarHighlightColorWithIntl, {
      popupsMountPoint: popupsMountPoint,
      popupsBoundariesElement: popupsBoundariesElement,
      popupsScrollableElement: popupsScrollableElement,
      disabled: disabled,
      isToolbarReducedSpacing: isToolbarReducedSpacing,
      pluginInjectionApi: api,
      editorView: editorView
    }) : /*#__PURE__*/_react.default.createElement(_ToolbarHighlightColor.ToolbarHighlightColorWithIntl, {
      popupsMountPoint: popupsMountPoint,
      popupsBoundariesElement: popupsBoundariesElement,
      popupsScrollableElement: popupsScrollableElement,
      disabled: disabled,
      isToolbarReducedSpacing: isToolbarReducedSpacing,
      pluginInjectionApi: api,
      editorView: editorView
    });
  };
  return {
    name: 'highlight',
    commands: {
      changeColor: (0, _commands.changeColor)(editorAnalyticsAPI)
    },
    pmPlugins: function pmPlugins() {
      return [{
        name: 'highlight',
        plugin: function plugin() {
          return (0, _main.createPlugin)({
            api: api
          });
        }
      }, {
        name: 'highlightKeymap',
        plugin: function plugin() {
          return (0, _keymap.keymapPlugin)({
            api: api
          });
        }
      }];
    },
    getSharedState: function getSharedState(editorState) {
      if (!editorState) {
        return;
      }
      return _main.highlightPluginKey.getState(editorState);
    },
    usePluginHook: function usePluginHook() {
      var _api$core, _api$primaryToolbar;
      api === null || api === void 0 || (_api$core = api.core) === null || _api$core === void 0 || _api$core.actions.execute(api === null || api === void 0 || (_api$primaryToolbar = api.primaryToolbar) === null || _api$primaryToolbar === void 0 ? void 0 : _api$primaryToolbar.commands.registerComponent({
        name: 'highlight',
        component: primaryToolbarComponent
      }));
    },
    pluginsOptions: {
      selectionToolbar: function selectionToolbar() {
        if (!(options !== null && options !== void 0 && options.textHighlightingFloatingToolbarExperiment) || !(0, _platformFeatureFlags.getBooleanFF)('platform.editor.enable-selection-toolbar_ucdwd')) {
          return;
        }
        var toolbarCustom = {
          type: 'custom',
          render: function render(_view, _idx, dispatchAnalyticsEvent) {
            return /*#__PURE__*/_react.default.createElement(_FloatingToolbarHighlightColor.FloatingToolbarHighlightColorWithIntl, {
              dispatchAnalyticsEvent: dispatchAnalyticsEvent,
              pluginInjectionApi: api
            });
          },
          fallback: []
        };
        return {
          rank: -9,
          isToolbarAbove: true,
          items: [toolbarCustom]
        };
      }
    },
    primaryToolbarComponent: !(api !== null && api !== void 0 && api.primaryToolbar) ? primaryToolbarComponent : undefined
  };
};