import React from 'react';
import { getBooleanFF } from '@atlaskit/platform-feature-flags';
import { changeColor } from './commands';
import { keymapPlugin } from './pm-plugins/keymap';
import { createPlugin, highlightPluginKey } from './pm-plugins/main';
import { FloatingToolbarHighlightColorWithIntl as FloatingToolbarHighlightColor } from './ui/FloatingToolbarHighlightColor';
import { PrimaryToolbarHighlightColorWithIntl as PrimaryToolbarHighlightColor } from './ui/PrimaryToolbarHighlightColor';
import { ToolbarHighlightColorWithIntl as ToolbarHighlightColor } from './ui/ToolbarHighlightColor';
export const highlightPlugin = ({
  api,
  config: options
}) => {
  var _api$analytics;
  const editorAnalyticsAPI = api === null || api === void 0 ? void 0 : (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions;
  const primaryToolbarComponent = ({
    popupsMountPoint,
    popupsBoundariesElement,
    popupsScrollableElement,
    disabled,
    isToolbarReducedSpacing,
    editorView
  }) => getBooleanFF('platform.editor.refactor-highlight-toolbar_mo0pj') ? /*#__PURE__*/React.createElement(PrimaryToolbarHighlightColor, {
    popupsMountPoint: popupsMountPoint,
    popupsBoundariesElement: popupsBoundariesElement,
    popupsScrollableElement: popupsScrollableElement,
    disabled: disabled,
    isToolbarReducedSpacing: isToolbarReducedSpacing,
    pluginInjectionApi: api,
    editorView: editorView
  }) : /*#__PURE__*/React.createElement(ToolbarHighlightColor, {
    popupsMountPoint: popupsMountPoint,
    popupsBoundariesElement: popupsBoundariesElement,
    popupsScrollableElement: popupsScrollableElement,
    disabled: disabled,
    isToolbarReducedSpacing: isToolbarReducedSpacing,
    pluginInjectionApi: api,
    editorView: editorView
  });
  return {
    name: 'highlight',
    commands: {
      changeColor: changeColor(editorAnalyticsAPI)
    },
    pmPlugins: () => [{
      name: 'highlight',
      plugin: () => createPlugin({
        api
      })
    }, {
      name: 'highlightKeymap',
      plugin: () => keymapPlugin({
        api
      })
    }],
    getSharedState(editorState) {
      if (!editorState) {
        return;
      }
      return highlightPluginKey.getState(editorState);
    },
    usePluginHook: () => {
      var _api$core, _api$primaryToolbar;
      api === null || api === void 0 ? void 0 : (_api$core = api.core) === null || _api$core === void 0 ? void 0 : _api$core.actions.execute(api === null || api === void 0 ? void 0 : (_api$primaryToolbar = api.primaryToolbar) === null || _api$primaryToolbar === void 0 ? void 0 : _api$primaryToolbar.commands.registerComponent({
        name: 'highlight',
        component: primaryToolbarComponent
      }));
    },
    pluginsOptions: {
      selectionToolbar() {
        if (!(options !== null && options !== void 0 && options.textHighlightingFloatingToolbarExperiment) || !getBooleanFF('platform.editor.enable-selection-toolbar_ucdwd')) {
          return;
        }
        const toolbarCustom = {
          type: 'custom',
          render: (_view, _idx, dispatchAnalyticsEvent) => /*#__PURE__*/React.createElement(FloatingToolbarHighlightColor, {
            dispatchAnalyticsEvent: dispatchAnalyticsEvent,
            pluginInjectionApi: api
          }),
          fallback: []
        };
        return {
          rank: -9,
          isToolbarAbove: true,
          items: [toolbarCustom]
        };
      }
    },
    primaryToolbarComponent: !(api !== null && api !== void 0 && api.primaryToolbar) ? primaryToolbarComponent : undefined
  };
};